]> git.proxmox.com Git - pve-kernel-meta.git/blob - bin/pve-efiboot-tool
d/copyright: update years
[pve-kernel-meta.git] / bin / pve-efiboot-tool
1 #!/bin/sh
2
3 set -e
4
5 . /usr/share/pve-kernel-helper/scripts/functions
6
7 _add_entry_to_list_file() {
8 file="$1"
9 entry="$2"
10
11 if [ -e "$file" ]; then
12 cp "$file" "$file.new"
13 fi
14 echo "$entry" >> "$file.new"
15 sort -uo "$file.new" "$file.new"
16 mv "$file.new" "$file"
17 }
18
19 _remove_entry_from_list_file() {
20 file="$1"
21 entry="$2"
22
23 # guard against removing whole file by accident!
24 if [ -z "$entry" ]; then
25 echo "cannot remove empty entry from '$file'."
26 return
27 fi
28
29 if [ -e "$file" ]; then
30 grep -vFx "$entry" "$file" > "$file.new" || true
31 mv "$file.new" "$file"
32 else
33 echo "'$file' does not exist.."
34 fi
35 }
36
37 _get_partition_info() {
38 if [ ! -e "$1" ]; then
39 warn "E: '$1' does not exist!"
40 exit 1
41 fi
42 bdev=$(realpath "$1")
43 if [ ! -b "$bdev" ]; then
44 warn "E: '$bdev' is not a block device!"
45 exit 1
46 fi
47
48 bdev_info=$( \
49 lsblk \
50 --bytes \
51 --pairs \
52 -o 'UUID,SIZE,FSTYPE,PARTTYPE,PKNAME,MOUNTPOINT' \
53 "$bdev" \
54 )
55 if [ -z "$bdev_info" ]; then
56 warn "E: unable to get information about block device '$1'!"
57 exit 1
58 fi
59
60 count=$(echo "$bdev_info" | grep -c '^')
61 if [ "$count" -ne '1' ]; then
62 echo "$bdev_info"
63 warn "E: block device '$1' has children!"
64 exit 1
65 fi
66
67 echo "$bdev_info"
68 eval "$bdev_info"
69
70 if [ -z "$PKNAME" ]; then
71 warn "E: cannot determine parent device of '$1' - please provide a partition, not a full disk."
72 exit 1
73 fi
74
75 if [ -n "$SIZE" ] && [ "$SIZE" -lt 268435456 ]; then
76 warn "E: '$1' is too small (<256M)."
77 exit 1
78 fi
79
80 if [ -n "$MOUNTPOINT" ]; then
81 warn "E: '$1' is mounted on '$MOUNTPOINT' - exiting."
82 exit 1
83 fi
84 }
85
86 format() {
87 part="$1"
88 force="$2"
89
90 _get_partition_info "$part"
91
92 if [ -n "$FSTYPE" ]; then
93 if [ -z "$force" ] || [ "$force" != '--force' ]; then
94 warn "E: '$part' contains a filesystem ('$FSTYPE') - exiting (use --force to override)"
95 exit 1
96 fi
97 fi
98
99 part_basename=$(basename "$part")
100 if [ -z "$part_basename" ]; then
101 warn "E: unable to determine basename of '$part'"
102 exit 1
103 fi
104
105 part_num=$(cat /sys/block/"$PKNAME"/"$part_basename"/partition)
106 if [ -z "$part_num" ]; then
107 warn "E: unable to determine partition number of '$part'"
108 exit 1
109 fi
110
111 if [ -z "$PARTTYPE" ] || [ "$PARTTYPE" != "$ESPTYPE" ]; then
112 echo "Setting partition type of '$part' to '$ESPTYPE'.."
113 sgdisk "-t$part_num:$ESPTYPE" "/dev/$PKNAME"
114 echo "Calling 'udevadm settle'.."
115 udevadm settle --timeout=5
116 fi
117
118 echo "Formatting '$part' as vfat.."
119 mkfs.vfat -F 32 "$part"
120 echo "Done."
121 exit 0
122 }
123
124 init() {
125 part="$1"
126
127 _get_partition_info "$part"
128
129 if [ -z "$PARTTYPE" ] || [ "$PARTTYPE" != "$ESPTYPE" ]; then
130 warn "E: '$part' has wrong partition type (!= $ESPTYPE)."
131 exit 1
132 fi
133
134 if [ -z "$FSTYPE" ] || [ "$FSTYPE" != 'vfat' ]; then
135 warn "E: '$part' has wrong filesystem (!= vfat)."
136 exit 1
137 fi
138
139 if [ -z "$UUID" ]; then
140 warn "E: '$part' has no UUID set, required for mounting."
141 exit 1
142 fi
143
144 esp_mp="/var/tmp/espmounts/$UUID"
145
146 mkdir -p "$esp_mp"
147 echo "Mounting '$part' on '$esp_mp'."
148 mount -t vfat "$part" "$esp_mp"
149
150 echo "Installing systemd-boot.."
151 mkdir -p "$esp_mp/$PMX_ESP_DIR"
152 bootctl --path "$esp_mp" install
153
154 echo "Configuring systemd-boot.."
155 echo "timeout 3" > "$esp_mp/$PMX_LOADER_CONF.tmp"
156 echo "default proxmox-*" >> "$esp_mp/$PMX_LOADER_CONF.tmp"
157 mv "$esp_mp/$PMX_LOADER_CONF.tmp" "$esp_mp/$PMX_LOADER_CONF"
158 echo "Unmounting '$part'."
159 umount "$part"
160
161 echo "Adding '$part' to list of synced ESPs.."
162 _add_entry_to_list_file "$ESP_LIST" "$UUID"
163
164 echo "Refreshing kernels and initrds.."
165 refresh
166 }
167
168 _clean_impl() {
169 if [ ! -e "/dev/disk/by-uuid/" ]; then
170 warn 'E: /dev/disk/by-uuid does not exist, aborting!'
171 exit 1
172 fi
173 echo -n "Checking whether ESP '$curr_uuid' exists.. "
174 if [ -e "/dev/disk/by-uuid/$curr_uuid" ]; then
175 echo "Found!"
176 else
177 echo "Not found!"
178 if [ -z "$dry_run" ] || [ "$dry_run" != '--dry-run' ]; then
179 _remove_entry_from_list_file "$ESP_LIST" "$curr_uuid"
180 fi
181 fi
182 }
183
184 clean() {
185 dry_run="$1"
186 rm -f "$ESP_LIST".tmp
187 loop_esp_list _clean_impl
188 if [ "$?" -eq 2 ]; then
189 warn "E: $ESP_LIST does not exist."
190 exit 1
191 fi
192 if [ -e "$ESP_LIST".tmp ]; then
193 mv "$ESP_LIST".tmp "$ESP_LIST"
194 fi
195 }
196
197 refresh() {
198 hook=$1
199 hookscripts='pve-auto-removal zz-pve-efiboot'
200
201 if [ -n "$hook" ]; then
202 if echo "$hookscripts" | grep -sqE "(^|[[:space:]]+)$hook([[:space:]]+|$)"; then
203 hookscripts="$hook"
204 else
205 warn "E: '$hook' is not a valid hook script name.";
206 exit 1;
207 fi
208 fi
209
210 for script in $hookscripts; do
211 scriptpath="/etc/kernel/postinst.d/$script"
212 if [ -f "$scriptpath" ] && [ -x "$scriptpath" ]; then
213 echo "Running hook script '$script'.."
214 $scriptpath
215 else
216 warn "Hook script '$script' not found or not executable, skipping."
217 fi
218 done
219 }
220
221 add_kernel() {
222 ver="$1"
223
224 if [ -z "$ver" ]; then
225 warn "E: <kernel-version> is mandatory"
226 warn ""
227 exit 1
228 fi
229
230 if [ ! -e "/boot/vmlinuz-$ver" ]; then
231 warn "E: no kernel image found in /boot for '$ver', not adding."
232 exit 1
233 fi
234 _add_entry_to_list_file "$MANUAL_KERNEL_LIST" "$ver"
235 echo "Added kernel '$ver' to manual kernel list. Use the 'refresh' command to update the ESPs."
236 }
237
238 remove_kernel() {
239 ver="$1"
240
241 if [ -z "$ver" ]; then
242 warn "E: <kernel-version> is mandatory"
243 warn ""
244 exit 1
245 fi
246
247 if grep -sqFx "$ver" "$MANUAL_KERNEL_LIST"; then
248 _remove_entry_from_list_file "$MANUAL_KERNEL_LIST" "$ver"
249 echo "Removed kernel '$ver' from manual kernel list. Use the 'refresh' command to update the ESPs."
250 else
251 echo "Kernel '$ver' not found in manual kernel list."
252 fi
253 }
254
255 list_kernels() {
256 boot_kernels="$(boot_kernel_list)"
257
258 if [ -e "$MANUAL_KERNEL_LIST" ]; then
259 manual_kernels="$(cat "$MANUAL_KERNEL_LIST" || true)"
260 boot_kernels="$(echo "$boot_kernels" | grep -Fxv -f "$MANUAL_KERNEL_LIST" || true)"
261 fi
262
263 if [ -z "$manual_kernels" ]; then
264 manual_kernels="None."
265 fi
266
267 echo "Manually selected kernels:"
268 echo "$manual_kernels"
269 echo ""
270 echo "Automatically selected kernels:"
271 echo "$boot_kernels"
272 }
273
274 usage() {
275 warn "USAGE: $0 <commands> [ARGS]"
276 warn ""
277 warn " $0 format <partition> [--force]"
278 warn " $0 init <partition>"
279 warn " $0 clean [--dry-run]"
280 warn " $0 refresh [--hook <name>]"
281 warn " $0 kernel <add|remove> <kernel-version>"
282 warn " $0 kernel list"
283 warn " $0 help"
284 }
285
286 help() {
287 echo "USAGE: $0 format <partition> [--force]"
288 echo ""
289 echo " format <partition> as EFI system partition. Use --force to format even if <partition> is currently in use."
290 echo ""
291 echo "USAGE: $0 init <partition>"
292 echo ""
293 echo " initialize EFI system partition at <partition> for automatic synchronization of pve-kernels and their associated initrds."
294 echo ""
295 echo "USAGE: $0 clean [--dry-run]"
296 echo ""
297 echo " remove no longer existing EFI system partition UUIDs from $ESP_LIST. Use --dry-run to only print outdated entries instead of removing them."
298 echo ""
299 echo "USAGE: $0 refresh [--hook <name>]"
300 echo ""
301 echo " refresh all configured EFI system partitions. Use --hook to only run the specified hook, omit to run all."
302 echo ""
303 echo "USAGE: $0 kernel <add|remove> <kernel-version>"
304 echo ""
305 echo " add/remove pve-kernel with ABI <kernel-version> to list of synced kernels, in addition to automatically selected ones."
306 echo " NOTE: you need to manually run 'refresh' once you're finished with adding/removing kernels from the list"
307 echo ""
308 echo "USAGE: $0 kernel list"
309 echo ""
310 echo " list kernel versions currently selected for inclusion on ESPs."
311 echo ""
312 }
313
314 if [ -z "$1" ]; then
315 usage
316 exit 0
317 fi
318
319 case "$1" in
320 'format')
321 shift
322 if [ -z "$1" ]; then
323 warn "E: <partition> is mandatory."
324 warn ""
325 usage
326 exit 1
327 fi
328 format "$@"
329 exit 0
330 ;;
331 'init')
332 reexec_in_mountns "$@"
333 shift
334 if [ -z "$1" ]; then
335 warn "E: <partition> is mandatory."
336 warn ""
337 usage
338 exit 1
339 fi
340 init "$@"
341 exit 0
342 ;;
343 'clean')
344 shift
345 clean "$@"
346 exit 0
347 ;;
348 'refresh')
349 shift
350 if [ "$#" -eq 0 ]; then
351 refresh
352 elif [ "$#" -eq 2 ] && [ "$1" = "--hook" ]; then
353 refresh "$2"
354 else
355 usage
356 exit 1
357 fi
358 exit 0
359 ;;
360 'kernel'|'kernels')
361 shift
362 if [ -z "$1" ]; then
363 warn "E: subcommand is mandatory for 'kernel'."
364 warn ""
365 usage
366 exit 1
367 fi
368 cmd="$1"
369 case "$cmd" in
370 'add')
371 add_kernel "$2"
372 exit 0
373 ;;
374 'remove')
375 remove_kernel "$2"
376 exit 0
377 ;;
378 'list')
379 list_kernels
380 exit 0
381 ;;
382 *)
383 warn "E: invalid 'kernel' subcommand '$cmd'."
384 warn ""
385 usage
386 exit 1
387 ;;
388 esac
389 ;;
390 'help')
391 shift
392 help
393 exit 0
394 ;;
395 *)
396 warn "Invalid/unknown command '$1'."
397 warn ""
398 usage
399 exit 1
400 ;;
401 esac
402
403 exit 1